#include "stm32f4xx_hal.h"
#include "stm32f4xx_hal_gpio.h"
#include "stm32f4xx_hal_rcc.h"
#include "stm32f4xx_hal_iwdg.h"


#include "../../work/STM32F40X_lib.c"

#include "../../work/displays/stm32f4_NOKIA5110_PCD8544_lib_web.c"

#define LED_PWR_PIN				GPIO_Pin_13
#define LED_PWR_GPIO_PORT		GPIOC
#define LED_PWR_GPIO_RCC		RCC_AHB1Periph_GPIOC

void MainWork(void){

	AHB1_ClockEnable(LED_PWR_GPIO_RCC);
	init_pin_opp(LED_PWR_GPIO_PORT,LED_PWR_PIN);

	//Led blinking
	GPIO_ClearBit(LED_PWR_GPIO_PORT,LED_PWR_PIN);
	delay_ms(100);
	GPIO_SetBit(LED_PWR_GPIO_PORT,LED_PWR_PIN);
	delay_ms(100);
	GPIO_ClearBit(LED_PWR_GPIO_PORT,LED_PWR_PIN);
	delay_ms(100);
	GPIO_SetBit(LED_PWR_GPIO_PORT,LED_PWR_PIN);

	lcd_Init();

	int32_t x = 0;
	int32_t y;
	uint8_t i;

	while(1){
		wdr();
		lcd_Clear();//Clear graphic buffer (Очищаем буфер)
		y = 0;
		for (i = 0; i < 47; i++){//Draw line (Рисуем вертикальную линию)
			lcd_PixelSet(x, y++);
		};
		lcd_Update();//Write buffer to LCD (Выводим данные в дисплей)
		x++; if (x == 83) x = 0;
		delay_ms(100);
	};
}
