/*
void iwdg_Init(uint32_t t_ms);//Время срабатывания в мс (максимум 26000 мс)
void JTAG_Off(void);
void AHB1_ClockEnable(uint32_t RCC_Periph);
void AHB1_ClockDisable(uint32_t RCC_Periph);
void AHB2_ClockEnable(uint32_t RCC_Periph);
void AHB2_ClockDisable(uint32_t RCC_Periph);

void init_pin_if(GPIO_TypeDef* GPIOx,uint16_t Pin);//Вход плавающий
void init_pin_ai(GPIO_TypeDef* GPIOx,uint16_t Pin);//Инициализация вывода на аналоговый вход
void init_pin_ipu(GPIO_TypeDef* GPIOx,uint16_t Pin);//Вход с подтягиванием вверх
void init_pin_ipd(GPIO_TypeDef* GPIOx,uint16_t Pin);//Вход с подтягиванием вниз
void init_pin_opp(GPIO_TypeDef* GPIOx,uint16_t Pin);//Выход
void init_pin_ood(GPIO_TypeDef* GPIOx,uint16_t Pin);//Выход с открытым коллектором
inline void GPIO_SetBit(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin);
inline void GPIO_ClearBit(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin);
inline uint32_t GPIO_ReadBit(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin);
uint16_t GPIO_ReadPort(GPIO_TypeDef* GPIOx);
void GPIO_WritePort(GPIO_TypeDef* GPIOx, uint16_t PortVal);
void GPIO_ToggleBit(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin);
*/

#define v_SysCount	uwTick
//For independent time count in functions
uint16_t v_WorkTimer=0;

//Override functions
void HAL_IncTick(void)
{
  uwTick += uwTickFreq;
  v_WorkTimer++;
}

uint32_t HAL_GetTick(void)
{
  return uwTick;
}

//inline void wdr(void){
//	IWDG->KR = IWDG_KEY_RELOAD;
//}

#define wdr()	(IWDG->KR = IWDG_KEY_RELOAD)

void delay_ms(uint32_t t){
	//HAL_Delay(t);
	  uint32_t tickstart = HAL_GetTick();
	  while((HAL_GetTick() - tickstart) < t)
	  {
		  wdr();
	  }
}

#define GPIO_Pin_0                 ((uint16_t)0x0001)  /* Pin 0 selected */
#define GPIO_Pin_1                 ((uint16_t)0x0002)  /* Pin 1 selected */
#define GPIO_Pin_2                 ((uint16_t)0x0004)  /* Pin 2 selected */
#define GPIO_Pin_3                 ((uint16_t)0x0008)  /* Pin 3 selected */
#define GPIO_Pin_4                 ((uint16_t)0x0010)  /* Pin 4 selected */
#define GPIO_Pin_5                 ((uint16_t)0x0020)  /* Pin 5 selected */
#define GPIO_Pin_6                 ((uint16_t)0x0040)  /* Pin 6 selected */
#define GPIO_Pin_7                 ((uint16_t)0x0080)  /* Pin 7 selected */
#define GPIO_Pin_8                 ((uint16_t)0x0100)  /* Pin 8 selected */
#define GPIO_Pin_9                 ((uint16_t)0x0200)  /* Pin 9 selected */
#define GPIO_Pin_10                ((uint16_t)0x0400)  /* Pin 10 selected */
#define GPIO_Pin_11                ((uint16_t)0x0800)  /* Pin 11 selected */
#define GPIO_Pin_12                ((uint16_t)0x1000)  /* Pin 12 selected */
#define GPIO_Pin_13                ((uint16_t)0x2000)  /* Pin 13 selected */
#define GPIO_Pin_14                ((uint16_t)0x4000)  /* Pin 14 selected */
#define GPIO_Pin_15                ((uint16_t)0x8000)  /* Pin 15 selected */
#define GPIO_Pin_All               ((uint16_t)0xFFFF)  /* All pins selected */


#define RCC_AHB1Periph_GPIOA             ((uint32_t)0x00000001)
#define RCC_AHB1Periph_GPIOB             ((uint32_t)0x00000002)
#define RCC_AHB1Periph_GPIOC             ((uint32_t)0x00000004)
#define RCC_AHB1Periph_GPIOD             ((uint32_t)0x00000008)
#define RCC_AHB1Periph_GPIOE             ((uint32_t)0x00000010)
#define RCC_AHB1Periph_GPIOF             ((uint32_t)0x00000020)
#define RCC_AHB1Periph_GPIOG             ((uint32_t)0x00000040)
#define RCC_AHB1Periph_GPIOH             ((uint32_t)0x00000080)
#define RCC_AHB1Periph_GPIOI             ((uint32_t)0x00000100)
#define RCC_AHB1Periph_CRC               ((uint32_t)0x00001000)
#define RCC_AHB1Periph_FLITF             ((uint32_t)0x00008000)
#define RCC_AHB1Periph_SRAM1             ((uint32_t)0x00010000)
#define RCC_AHB1Periph_SRAM2             ((uint32_t)0x00020000)
#define RCC_AHB1Periph_BKPSRAM           ((uint32_t)0x00040000)
#define RCC_AHB1Periph_CCMDATARAMEN      ((uint32_t)0x00100000)
#define RCC_AHB1Periph_DMA1              ((uint32_t)0x00200000)
#define RCC_AHB1Periph_DMA2              ((uint32_t)0x00400000)
#define RCC_AHB1Periph_ETH_MAC           ((uint32_t)0x02000000)
#define RCC_AHB1Periph_ETH_MAC_Tx        ((uint32_t)0x04000000)
#define RCC_AHB1Periph_ETH_MAC_Rx        ((uint32_t)0x08000000)
#define RCC_AHB1Periph_ETH_MAC_PTP       ((uint32_t)0x10000000)
#define RCC_AHB1Periph_OTG_HS            ((uint32_t)0x20000000)
#define RCC_AHB1Periph_OTG_HS_ULPI       ((uint32_t)0x40000000)

#define RCC_AHB2Periph_DCMI              ((uint32_t)0x00000001)
#define RCC_AHB2Periph_CRYP              ((uint32_t)0x00000010)
#define RCC_AHB2Periph_HASH              ((uint32_t)0x00000020)
#define RCC_AHB2Periph_RNG               ((uint32_t)0x00000040)
#define RCC_AHB2Periph_OTG_FS            ((uint32_t)0x00000080)



void AHB1_ClockEnable(uint32_t RCC_Periph){
RCC->AHB1ENR |= RCC_Periph;
}

void AHB1_ClockDisable(uint32_t RCC_Periph){
RCC->AHB1ENR &= ~RCC_Periph;
}

void AHB2_ClockEnable(uint32_t RCC_Periph){
RCC->AHB2ENR |= RCC_Periph;
}

void AHB2_ClockDisable(uint32_t RCC_Periph){
RCC->AHB2ENR &= ~RCC_Periph;
}

void JTAG_Off(void){

}

//Analog in
void init_pin_ai(GPIO_TypeDef* GPIOx,uint16_t PinNum){
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	GPIO_InitStruct.Pin = PinNum;
	GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
	GPIO_InitStruct.Pull = GPIO_NOPULL;
	GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
	HAL_GPIO_Init(GPIOx, &GPIO_InitStruct);
}

//Input pull up
void init_pin_ipu(GPIO_TypeDef* GPIOx,uint16_t PinNum){
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	GPIO_InitStruct.Pin = PinNum;
	GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
	GPIO_InitStruct.Pull = GPIO_PULLUP;
	GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
	HAL_GPIO_Init(GPIOx, &GPIO_InitStruct);
}

//Input pull down
void init_pin_ipd(GPIO_TypeDef* GPIOx,uint16_t PinNum){
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	GPIO_InitStruct.Pin = PinNum;
	GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
	GPIO_InitStruct.Pull = GPIO_PULLDOWN;
	GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
	HAL_GPIO_Init(GPIOx, &GPIO_InitStruct);
}

//Input float
void init_pin_if(GPIO_TypeDef* GPIOx,uint16_t PinNum){
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	GPIO_InitStruct.Pin = PinNum;
	GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
	GPIO_InitStruct.Pull = GPIO_NOPULL;
	GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
	HAL_GPIO_Init(GPIOx, &GPIO_InitStruct);
}

//Output push-pull
void init_pin_opp(GPIO_TypeDef* GPIOx,uint16_t PinNum){
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	GPIO_InitStruct.Pin = PinNum;
	GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
	GPIO_InitStruct.Pull = GPIO_NOPULL;
	GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
	HAL_GPIO_Init(GPIOx, &GPIO_InitStruct);
}

//Output open drain
void init_pin_ood(GPIO_TypeDef* GPIOx,uint16_t PinNum){
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	GPIO_InitStruct.Pin = PinNum;
	GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
	GPIO_InitStruct.Pull = GPIO_NOPULL;
	GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
	HAL_GPIO_Init(GPIOx, &GPIO_InitStruct);
}

//Output open drain pull up
void init_pin_ood_pu(GPIO_TypeDef* GPIOx,uint16_t PinNum){
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	GPIO_InitStruct.Pin = PinNum;
	GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
	GPIO_InitStruct.Pull = GPIO_PULLUP;
	GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
	HAL_GPIO_Init(GPIOx, &GPIO_InitStruct);
}

//Output alternate push-pull
void init_pin_afpp(GPIO_TypeDef* GPIOx,uint16_t PinNum){

}

//Output alternate open drain
void init_pin_afod(GPIO_TypeDef* GPIOx,uint16_t PinNum){

}

void GPIO_SetBit(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin){
	GPIOx->BSRR = GPIO_Pin;
}

void GPIO_ClearBit(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin){
	GPIOx->BSRR = (uint32_t)GPIO_Pin << 16U;
}

uint32_t GPIO_ReadBit(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin){
	return (GPIOx->IDR & GPIO_Pin);
}

uint16_t GPIO_ReadPort(GPIO_TypeDef* GPIOx){
	return ((uint16_t)GPIOx->IDR);
}

void GPIO_WritePort(GPIO_TypeDef* GPIOx, uint16_t PortVal){
	GPIOx->ODR = PortVal;
}

void GPIO_ToggleBit(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin){
	GPIOx->ODR ^= GPIO_Pin;
}

/*
HAL_UART_Transmit(&huart3, &n, 1, 30);
if (HAL_UART_Receive(&huart3,v_Buf,12000,900)==0){

	};
 */
